package org.codehaus.plexus.redback.users.provider.test;

/*
 * Copyright 2001-2006 The Codehaus.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import org.codehaus.plexus.redback.users.User;
import org.codehaus.plexus.redback.users.UserManagerListener;

import java.util.ArrayList;
import java.util.List;

/**
 * UserManagerEventTracker 
 *
 * @author <a href="mailto:joakim@erdfelt.com">Joakim Erdfelt</a>
 * @version $Id: UserManagerEventTracker.java 776 2009-03-10 18:08:30Z brett $
 */
public class UserManagerEventTracker
    implements UserManagerListener
{
    public long countInit = 0;

    public Boolean lastDbFreshness;

    public List<String> addedUsernames = new ArrayList<String>();

    public List<String> removedUsernames = new ArrayList<String>();

    public List<String> updatedUsernames = new ArrayList<String>();

    public void userManagerInit( boolean freshDatabase )
    {
        countInit++;
        lastDbFreshness = Boolean.valueOf( freshDatabase );
    }

    private void addUniqueUsername( List<String> list, User user )
    {
        if ( !list.contains( user.getUsername() ) )
        {
            list.add( user.getUsername() );
        }
    }

    public void userManagerUserAdded( User user )
    {
        addUniqueUsername( addedUsernames, user );
    }

    public void userManagerUserRemoved( User user )
    {
        addUniqueUsername( removedUsernames, user );
    }

    public void userManagerUserUpdated( User user )
    {
        addUniqueUsername( updatedUsernames, user );
    }
}
